// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from mavros_msgs:srv/ParamGet.idl
// generated code does not contain a copyright notice
#include "mavros_msgs/srv/detail/param_get__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `param_id`
#include "rosidl_runtime_c/string_functions.h"

bool
mavros_msgs__srv__ParamGet_Request__init(mavros_msgs__srv__ParamGet_Request * msg)
{
  if (!msg) {
    return false;
  }
  // param_id
  if (!rosidl_runtime_c__String__init(&msg->param_id)) {
    mavros_msgs__srv__ParamGet_Request__fini(msg);
    return false;
  }
  return true;
}

void
mavros_msgs__srv__ParamGet_Request__fini(mavros_msgs__srv__ParamGet_Request * msg)
{
  if (!msg) {
    return;
  }
  // param_id
  rosidl_runtime_c__String__fini(&msg->param_id);
}

bool
mavros_msgs__srv__ParamGet_Request__are_equal(const mavros_msgs__srv__ParamGet_Request * lhs, const mavros_msgs__srv__ParamGet_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // param_id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->param_id), &(rhs->param_id)))
  {
    return false;
  }
  return true;
}

bool
mavros_msgs__srv__ParamGet_Request__copy(
  const mavros_msgs__srv__ParamGet_Request * input,
  mavros_msgs__srv__ParamGet_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // param_id
  if (!rosidl_runtime_c__String__copy(
      &(input->param_id), &(output->param_id)))
  {
    return false;
  }
  return true;
}

mavros_msgs__srv__ParamGet_Request *
mavros_msgs__srv__ParamGet_Request__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  mavros_msgs__srv__ParamGet_Request * msg = (mavros_msgs__srv__ParamGet_Request *)allocator.allocate(sizeof(mavros_msgs__srv__ParamGet_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(mavros_msgs__srv__ParamGet_Request));
  bool success = mavros_msgs__srv__ParamGet_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
mavros_msgs__srv__ParamGet_Request__destroy(mavros_msgs__srv__ParamGet_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    mavros_msgs__srv__ParamGet_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
mavros_msgs__srv__ParamGet_Request__Sequence__init(mavros_msgs__srv__ParamGet_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  mavros_msgs__srv__ParamGet_Request * data = NULL;

  if (size) {
    data = (mavros_msgs__srv__ParamGet_Request *)allocator.zero_allocate(size, sizeof(mavros_msgs__srv__ParamGet_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = mavros_msgs__srv__ParamGet_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        mavros_msgs__srv__ParamGet_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
mavros_msgs__srv__ParamGet_Request__Sequence__fini(mavros_msgs__srv__ParamGet_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      mavros_msgs__srv__ParamGet_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

mavros_msgs__srv__ParamGet_Request__Sequence *
mavros_msgs__srv__ParamGet_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  mavros_msgs__srv__ParamGet_Request__Sequence * array = (mavros_msgs__srv__ParamGet_Request__Sequence *)allocator.allocate(sizeof(mavros_msgs__srv__ParamGet_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = mavros_msgs__srv__ParamGet_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
mavros_msgs__srv__ParamGet_Request__Sequence__destroy(mavros_msgs__srv__ParamGet_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    mavros_msgs__srv__ParamGet_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
mavros_msgs__srv__ParamGet_Request__Sequence__are_equal(const mavros_msgs__srv__ParamGet_Request__Sequence * lhs, const mavros_msgs__srv__ParamGet_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!mavros_msgs__srv__ParamGet_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
mavros_msgs__srv__ParamGet_Request__Sequence__copy(
  const mavros_msgs__srv__ParamGet_Request__Sequence * input,
  mavros_msgs__srv__ParamGet_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(mavros_msgs__srv__ParamGet_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    mavros_msgs__srv__ParamGet_Request * data =
      (mavros_msgs__srv__ParamGet_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!mavros_msgs__srv__ParamGet_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          mavros_msgs__srv__ParamGet_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!mavros_msgs__srv__ParamGet_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `value`
#include "mavros_msgs/msg/detail/param_value__functions.h"

bool
mavros_msgs__srv__ParamGet_Response__init(mavros_msgs__srv__ParamGet_Response * msg)
{
  if (!msg) {
    return false;
  }
  // success
  // value
  if (!mavros_msgs__msg__ParamValue__init(&msg->value)) {
    mavros_msgs__srv__ParamGet_Response__fini(msg);
    return false;
  }
  return true;
}

void
mavros_msgs__srv__ParamGet_Response__fini(mavros_msgs__srv__ParamGet_Response * msg)
{
  if (!msg) {
    return;
  }
  // success
  // value
  mavros_msgs__msg__ParamValue__fini(&msg->value);
}

bool
mavros_msgs__srv__ParamGet_Response__are_equal(const mavros_msgs__srv__ParamGet_Response * lhs, const mavros_msgs__srv__ParamGet_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // success
  if (lhs->success != rhs->success) {
    return false;
  }
  // value
  if (!mavros_msgs__msg__ParamValue__are_equal(
      &(lhs->value), &(rhs->value)))
  {
    return false;
  }
  return true;
}

bool
mavros_msgs__srv__ParamGet_Response__copy(
  const mavros_msgs__srv__ParamGet_Response * input,
  mavros_msgs__srv__ParamGet_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // success
  output->success = input->success;
  // value
  if (!mavros_msgs__msg__ParamValue__copy(
      &(input->value), &(output->value)))
  {
    return false;
  }
  return true;
}

mavros_msgs__srv__ParamGet_Response *
mavros_msgs__srv__ParamGet_Response__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  mavros_msgs__srv__ParamGet_Response * msg = (mavros_msgs__srv__ParamGet_Response *)allocator.allocate(sizeof(mavros_msgs__srv__ParamGet_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(mavros_msgs__srv__ParamGet_Response));
  bool success = mavros_msgs__srv__ParamGet_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
mavros_msgs__srv__ParamGet_Response__destroy(mavros_msgs__srv__ParamGet_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    mavros_msgs__srv__ParamGet_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
mavros_msgs__srv__ParamGet_Response__Sequence__init(mavros_msgs__srv__ParamGet_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  mavros_msgs__srv__ParamGet_Response * data = NULL;

  if (size) {
    data = (mavros_msgs__srv__ParamGet_Response *)allocator.zero_allocate(size, sizeof(mavros_msgs__srv__ParamGet_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = mavros_msgs__srv__ParamGet_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        mavros_msgs__srv__ParamGet_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
mavros_msgs__srv__ParamGet_Response__Sequence__fini(mavros_msgs__srv__ParamGet_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      mavros_msgs__srv__ParamGet_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

mavros_msgs__srv__ParamGet_Response__Sequence *
mavros_msgs__srv__ParamGet_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  mavros_msgs__srv__ParamGet_Response__Sequence * array = (mavros_msgs__srv__ParamGet_Response__Sequence *)allocator.allocate(sizeof(mavros_msgs__srv__ParamGet_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = mavros_msgs__srv__ParamGet_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
mavros_msgs__srv__ParamGet_Response__Sequence__destroy(mavros_msgs__srv__ParamGet_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    mavros_msgs__srv__ParamGet_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
mavros_msgs__srv__ParamGet_Response__Sequence__are_equal(const mavros_msgs__srv__ParamGet_Response__Sequence * lhs, const mavros_msgs__srv__ParamGet_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!mavros_msgs__srv__ParamGet_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
mavros_msgs__srv__ParamGet_Response__Sequence__copy(
  const mavros_msgs__srv__ParamGet_Response__Sequence * input,
  mavros_msgs__srv__ParamGet_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(mavros_msgs__srv__ParamGet_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    mavros_msgs__srv__ParamGet_Response * data =
      (mavros_msgs__srv__ParamGet_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!mavros_msgs__srv__ParamGet_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          mavros_msgs__srv__ParamGet_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!mavros_msgs__srv__ParamGet_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `info`
#include "service_msgs/msg/detail/service_event_info__functions.h"
// Member `request`
// Member `response`
// already included above
// #include "mavros_msgs/srv/detail/param_get__functions.h"

bool
mavros_msgs__srv__ParamGet_Event__init(mavros_msgs__srv__ParamGet_Event * msg)
{
  if (!msg) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__init(&msg->info)) {
    mavros_msgs__srv__ParamGet_Event__fini(msg);
    return false;
  }
  // request
  if (!mavros_msgs__srv__ParamGet_Request__Sequence__init(&msg->request, 0)) {
    mavros_msgs__srv__ParamGet_Event__fini(msg);
    return false;
  }
  // response
  if (!mavros_msgs__srv__ParamGet_Response__Sequence__init(&msg->response, 0)) {
    mavros_msgs__srv__ParamGet_Event__fini(msg);
    return false;
  }
  return true;
}

void
mavros_msgs__srv__ParamGet_Event__fini(mavros_msgs__srv__ParamGet_Event * msg)
{
  if (!msg) {
    return;
  }
  // info
  service_msgs__msg__ServiceEventInfo__fini(&msg->info);
  // request
  mavros_msgs__srv__ParamGet_Request__Sequence__fini(&msg->request);
  // response
  mavros_msgs__srv__ParamGet_Response__Sequence__fini(&msg->response);
}

bool
mavros_msgs__srv__ParamGet_Event__are_equal(const mavros_msgs__srv__ParamGet_Event * lhs, const mavros_msgs__srv__ParamGet_Event * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__are_equal(
      &(lhs->info), &(rhs->info)))
  {
    return false;
  }
  // request
  if (!mavros_msgs__srv__ParamGet_Request__Sequence__are_equal(
      &(lhs->request), &(rhs->request)))
  {
    return false;
  }
  // response
  if (!mavros_msgs__srv__ParamGet_Response__Sequence__are_equal(
      &(lhs->response), &(rhs->response)))
  {
    return false;
  }
  return true;
}

bool
mavros_msgs__srv__ParamGet_Event__copy(
  const mavros_msgs__srv__ParamGet_Event * input,
  mavros_msgs__srv__ParamGet_Event * output)
{
  if (!input || !output) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__copy(
      &(input->info), &(output->info)))
  {
    return false;
  }
  // request
  if (!mavros_msgs__srv__ParamGet_Request__Sequence__copy(
      &(input->request), &(output->request)))
  {
    return false;
  }
  // response
  if (!mavros_msgs__srv__ParamGet_Response__Sequence__copy(
      &(input->response), &(output->response)))
  {
    return false;
  }
  return true;
}

mavros_msgs__srv__ParamGet_Event *
mavros_msgs__srv__ParamGet_Event__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  mavros_msgs__srv__ParamGet_Event * msg = (mavros_msgs__srv__ParamGet_Event *)allocator.allocate(sizeof(mavros_msgs__srv__ParamGet_Event), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(mavros_msgs__srv__ParamGet_Event));
  bool success = mavros_msgs__srv__ParamGet_Event__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
mavros_msgs__srv__ParamGet_Event__destroy(mavros_msgs__srv__ParamGet_Event * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    mavros_msgs__srv__ParamGet_Event__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
mavros_msgs__srv__ParamGet_Event__Sequence__init(mavros_msgs__srv__ParamGet_Event__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  mavros_msgs__srv__ParamGet_Event * data = NULL;

  if (size) {
    data = (mavros_msgs__srv__ParamGet_Event *)allocator.zero_allocate(size, sizeof(mavros_msgs__srv__ParamGet_Event), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = mavros_msgs__srv__ParamGet_Event__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        mavros_msgs__srv__ParamGet_Event__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
mavros_msgs__srv__ParamGet_Event__Sequence__fini(mavros_msgs__srv__ParamGet_Event__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      mavros_msgs__srv__ParamGet_Event__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

mavros_msgs__srv__ParamGet_Event__Sequence *
mavros_msgs__srv__ParamGet_Event__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  mavros_msgs__srv__ParamGet_Event__Sequence * array = (mavros_msgs__srv__ParamGet_Event__Sequence *)allocator.allocate(sizeof(mavros_msgs__srv__ParamGet_Event__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = mavros_msgs__srv__ParamGet_Event__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
mavros_msgs__srv__ParamGet_Event__Sequence__destroy(mavros_msgs__srv__ParamGet_Event__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    mavros_msgs__srv__ParamGet_Event__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
mavros_msgs__srv__ParamGet_Event__Sequence__are_equal(const mavros_msgs__srv__ParamGet_Event__Sequence * lhs, const mavros_msgs__srv__ParamGet_Event__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!mavros_msgs__srv__ParamGet_Event__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
mavros_msgs__srv__ParamGet_Event__Sequence__copy(
  const mavros_msgs__srv__ParamGet_Event__Sequence * input,
  mavros_msgs__srv__ParamGet_Event__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(mavros_msgs__srv__ParamGet_Event);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    mavros_msgs__srv__ParamGet_Event * data =
      (mavros_msgs__srv__ParamGet_Event *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!mavros_msgs__srv__ParamGet_Event__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          mavros_msgs__srv__ParamGet_Event__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!mavros_msgs__srv__ParamGet_Event__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
